﻿using System;
using BlazorApp.Models;
using Microsoft.AspNetCore.Components;
using Microsoft.JSInterop;
using System.Collections.ObjectModel;
using System.Collections.Specialized;
using BlazorApp.Services;
using Blazorise.DataGrid;

namespace BlazorApp.Components
{
    public partial class InventoryComp
    {

        public Item CurrentDragItem { get; set; }

        public int CurrentDragIndex { get; set; }

        [Inject]
        public IDataService DataService { get; set; }

        [Parameter]
        public List<Item> Items { get; set; }

        public List<Item> InventoryItems { get; set; }

        public List<InventoryItem> InvItems { get; set; }

        private int totalItem;

        public InventoryComp()
        {
            this.InventoryItems = new List<Item> { };
            for (int i = 0; i < 18; i++)
            {
                this.InventoryItems.Append(null);
            }
        }

        private async Task OnReadData(DataGridReadDataEventArgs<InventoryItem> e)
        {
            if (e.CancellationToken.IsCancellationRequested)
            {
                return;
            }

            if (!e.CancellationToken.IsCancellationRequested)
            {
                Items = await DataService.List(e.Page, e.PageSize);
                totalItem = await DataService.Count();
                foreach (Item i in Items){
                    InventoryItem newI = new InventoryItem();
                    newI.Item = i;
                    InvItems.Append(newI);
                } 
            }
        }

        private async Task SortByName()
        {
            Items = await DataService.SortedList();
        }

    }
}